package com.rjconsultores.ventaboletos.service.impl;

import java.util.Calendar;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.rjconsultores.ventaboletos.dao.PrecoApanheDAO;
import com.rjconsultores.ventaboletos.entidad.PrecoApanhe;
import com.rjconsultores.ventaboletos.service.PrecoApanheService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;

@Service("precoApanheService")
public class PrecoApanheServiceImpl implements PrecoApanheService {

    @Autowired
    private PrecoApanheDAO precoApanheDAO;

    public List<PrecoApanhe> obtenerTodos() {
        return precoApanheDAO.obtenerTodos();
    }

    public PrecoApanhe obtenerID(Integer id) {
        return precoApanheDAO.obtenerID(id);
    }

    @Transactional
    public PrecoApanhe suscribir(PrecoApanhe entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return precoApanheDAO.suscribir(entidad);
    }

    @Transactional
    public PrecoApanhe actualizacion(PrecoApanhe entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return precoApanheDAO.actualizacion(entidad);
    }

    @Transactional
    public void borrar(PrecoApanhe entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.FALSE);

        precoApanheDAO.actualizacion(entidad);
    }

    public List<PrecoApanhe> buscar(String deschotel, String desccolonia, String nombciudad) {
        return precoApanheDAO.buscar(deschotel, desccolonia, nombciudad);
    }
}
